<?php

include( $_SERVER['DOCUMENT_ROOT'] . "/include/inc.php");



require_once( $_SERVER['DOCUMENT_ROOT'].'/include/PHPExcel.php' );
require_once( $_SERVER['DOCUMENT_ROOT'].'/include/classes/smarty/Config_File.class.php' );
$cacheSettings = array( 'memoryCacheSize' => Site()->Config('memmory_reports')."M");
PHPExcel_Settings::setCacheStorageMethod(PHPExcel_CachedObjectStorageFactory::cache_to_phpTemp,$cacheSettings);


$conf_loaded = array();

$path_to_conf_dir = $_SERVER['DOCUMENT_ROOT']. "/configs";

$config = new Config_File();
$config->booleanize = false;

foreach (scandir( $path_to_conf_dir ) as $name_conf_file) {
  if( !preg_match('/([a-z]*)_lang.conf/' , $name_conf_file , $match )){
    continue;
  }
  $conf_loaded[ $match[1] ] = $config->parse_contents( file_get_contents( $path_to_conf_dir . "/" . $name_conf_file ));
}

// Уникальные индексы 
$uniq_index = array();


// Вынесем все конфиги локали на один уровень
$locale_indexes = array();

foreach( $conf_loaded as $locale => $lang_conf ){
  foreach ($lang_conf['sections'] as $section_name => $conf) {
    foreach( $conf['vars'] as $index => $var ){
      $uniq_index[ $index ] = array();
      $locale_indexes[$locale][$index] = $var;
    }
  }
  foreach( $conf['vars'] as $index => $var ){
    $uniq_index[ $index ] = array();
    $locale_indexes[$locale][$index] = $var;
  }
}
 

$output = array();

$head = array("INDEX");
foreach (array_keys( $locale_indexes ) as $locale ) {
  $head[] = strtoupper($locale);
}
$output[] = $head;


//Получение всех ключей глобальных переменных(те ,что не в секциях)
$global_keys = array();
foreach (array_keys($locale_indexes) as $lang) {
  foreach (array_keys($conf_loaded[$lang]['vars']) as $item) {
    $global_keys[] = $item;
  }
}
$global_keys = array_unique($global_keys);

//Запись в $output[] значений глобальных переменных
foreach ($global_keys as $item){
  $word = array();
  foreach (array_keys( $locale_indexes ) as $lang){
    $word[] = $conf_loaded[$lang]['vars'][$item];
  }  
  $row = array($item);
  foreach ($word as $item){
    $row[] = $item;
  }
  $output[] = $row;
}

//Получение всех секций 
$sections = array();
foreach (array_keys($locale_indexes) as $lang) {
  foreach (array_keys($conf_loaded[$lang]['sections']) as $item) {
    $sections[] = $item;
  }
}
$sections = array_unique($sections);

//Получение ключей в секциях
$section_keys = array();
foreach (array_keys($locale_indexes) as $lang) {
  foreach ($sections as $section) {
    foreach (array_keys($conf_loaded[$lang]['sections'][$section]['vars']) as $item) {
      $section_keys[] = $item;
    }
  }
}
$section_keys = array_unique($section_keys);

//Запись секций и значений в $output[]
foreach ($sections as $section) {
  $section_name = array();
  $section_name[] = "[$section]";
  $output[] = $section_name;

  $config_vars = array();
  $row = array();
  foreach (array_keys($locale_indexes) as $lang) {
    foreach ($conf_loaded[$lang]['sections'][$section]['vars'] as $config_var => $config_value) {
      $config_vars[] = $config_var;
    }
  }
  $config_vars = array_unique($config_vars);

  $words = array();
  foreach ($config_vars as $config_var) {
    $word = array();
    $word[] = $config_var;
    foreach (array_keys($locale_indexes) as $lang) {
      $word[] = $conf_loaded[$lang]['sections'][$section]['vars'][$config_var];
    }
    $output[] = $word;
  }
}

$objPHPExcel = new PHPExcel();

$objPHPExcel->getActiveSheet()->fromArray( $output, null, 'A1');
foreach(range('A','Z') as $columnID) {
    $objPHPExcel->getActiveSheet()->getColumnDimension($columnID)
        ->setAutoSize(true);
}

@header( "Content-Type: application/vnd.ms-excel" );
@header( 'Content-Disposition: attachment;filename="'. "nagruzka_i18n.xls" .'"' );
@header( 'Expires: Mon, 26 Jul 1997 05:00:00 GMT' );
@header( 'Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT' );
@header( "Cache-Control: no-store, no-cache, must-revalidate" );
@header( 'Pragma: public' );
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5' );

$objWriter->save('php://output');
