<?php
include '../include/PHPExcel/IOFactory.php';


if (!empty($_FILES)) {
  $inputFileName = $_FILES['file']['tmp_name'];
  $inputFileType = PHPExcel_IOFactory::identify($inputFileName);
  $objReader = PHPExcel_IOFactory::createReader($inputFileType);
  $objPHPExcel = $objReader->load($inputFileName);
  $sheet = $objPHPExcel->getSheet(0);
  $highestRow = $sheet->getHighestRow();
  $highestColumn = $sheet->getHighestColumn();

  //Импорт ячеек из .xls в массив 
  $import_data = $objPHPExcel->getActiveSheet()->toArray(null, false, true, false);

  //Очистка пустых ключей массива ([3]=> , [4]=> , [5]=> ... [25]=>)
  $result_array = array();
  foreach ($import_data as $row) {
    $result_array[] = array_filter($row);
  }

  //Список имортируемых языков
  $imported_langs = array();
  foreach ($result_array[0] as $lang) {
    if ($lang != "INDEX") {
      $imported_langs[] = strtolower($lang);
    }
  }
  
  //Регулярка секций
  $section_pattern = "/([)+([A-z]*)+(])/";
  
  //Имена файлов для добавления в архив
  $files_to_archive = array();
  
  //Импорт из массива в .conf файлы
  foreach ($imported_langs as $lang_key => $lang_val) {
    $config_name = $lang_val . "_lang.conf";
    $files_to_archive[] = $config_name;
    $config_file = fopen($config_name, "w");
    foreach ($result_array as $row_key => $row) {
      $word_key = $lang_key + 1;
      foreach ($row as $key => $item) {
        if ($row_key != 0) {
          if (!(preg_match($section_pattern, $item))) {
            if (count($row) > 1) {
              if ($key == 0) {
                fwrite($config_file, $item . " = \"");
              }
              if ($key == $word_key) {
                fwrite($config_file, $item . "\"\n");
              }
            } else {
              fwrite($config_file, $item . " = \"\"\n");
            }
          } else {
            //Если элемент - секция
            fwrite($config_file, "\n" . $item . "\n");
          }
        }
      }
    }
  }

  //Создаем zip архив и записываем в него файлы
  $zipname = 'configs.zip';
  $zip = new ZipArchive;
  $zip->open($zipname, ZipArchive::CREATE); 
  foreach ($files_to_archive as $file) {
    $zip->addFile($file);
  }  
  $zip->close();
  
  //Скачиваем архив
  header('Content-Type: application/zip');
  header('Content-disposition: attachment; filename=' . $zipname);
  header('Content-Length: ' . filesize($zipname));
  readfile($zipname);
  //Удаление zip архива из папки /set_lang
  unlink($zipname);
  
  //Удаление конфиг файлов из /set_lang
  foreach ($files_to_archive as $file){
    unlink($file);
  }
}
?>

<form enctype='multipart/form-data' action='import.php' method='POST'>    
  <input type='hidden'/> 

  File: <input name='file' type='file' />
  </br>  
  </br>
  <input type='submit' value='Import' />
</form>